<?php
class plgHikamarketVendorpayinvoice extends JPlugin {
	/**
	 *
	 * @param string $subject
	 * @param object $config
	 */
	public function __construct(&$subject, $config) {
		parent::__construct($subject, $config);
	}

	/**
	 *
	 */
	public function onBeforeVendorPay(&$order, &$vendor, &$orders, &$pay_orders, &$do) {
		$config = hikamarket::config();
		$this->feeMode = ($config->get('market_mode', 'fee') == 'fee');
		$this->invoice = hikamarket::cloning($order);
	}
	
	/**
	 *
	 */
	public function onAfterVendorPay(&$order, &$vendor, &$orders, &$pay_orders) {
		if(!$this->feeMode)
			return;

		$invoice = $this->invoice;
		if(empty($this->invoice))
			return;

		$vendorClass = hikamarket::get('class.vendor');
		$shopOrderClass = hikamarket::get('shop.class.order');
		$currencyClass = hikamarket::get('shop.class.currency');
		$shopConfig = hikamarket::config(false);
		$confirmedStatus = $shopConfig->get('order_confirmed_status', 'confirmed');

		unset($invoice->order_id);
		$invoice->order_status = $confirmedStatus;
		$invoice->order_type = 'sale';
		$invoice->order_payment_id = 0;
		$invoice->history->history_notified = 1;
		$invoice->order_billing_address_id = $vendorClass->getAddressId($vendor);
		$invoice->cart->products = array();
		foreach($pay_orders as $o) {
			$product = new stdClass();
			$product->product_id = 0;
			$product->order_product_name = JText::sprintf('VENDOR_ORDER_PAYMENT', $o->order_number, $currencyClass->format($o->order_full_price, $o->order_currency_id));
			$product->order_product_code = '#' . $o->order_id;
			$product->order_product_price = $currencyClass->convertUniquePrice($o->order_full_price - $o->order_shipping_price - $o->order_payment_price - $o->order_vendor_price, $o->order_currency_id, $vendor->vendor_currency_id);
			$product->order_product_quantity = 1;
			$product->order_product_tax = 0;
			$product->order_product_options = '';
			$invoice->cart->products[] = $product;
		}
		$shopOrderClass->recalculateFullPrice($invoice, $invoice->cart->products);
		$shopOrderClass->save($invoice);
	}
}